///home/berryj/link/bin/genMethods "-g" "-t" "Vertex*" "-h" "MSet" "-r" "Collection<Vertex*>" "-I" "LINK/basic/MSet.h" "-I" "LINK/graph/Vertex.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/MSet.h>

#include <LINK/graph/Vertex.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Vertex* _Vertex_;
typedef MSet<Vertex* > _MSet_Vertex__;
static MSet<Vertex* > s__MSet_Vertex__;

#define _MSet_Vertex__DATA(x) ((MSet<Vertex* >*) (EXTDATA(x)))
#define _MSet_Vertex__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MSet<Vertex* > >::type))
#define _MSet_Vertex__ISNT_DATA(x) (!_MSet_Vertex__IS_DATA(x))

#define _MSet_Vertex__CXX_DATA(x) (*(MSet<Vertex* >*) (EXTDATA(VAL(x))))
#define _MSet_Vertex__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MSet<Vertex* > >::type))
#define _MSet_Vertex__CXX_ISNT_DATA(x) (!_MSet_Vertex__CXX_IS_DATA(x))


PRIMITIVE STk_init__MSet_Vertex__()
{
	Wrapper<_MSet_Vertex__>::type = STk_new_CXXwrapper_id(
			Wrapper<_MSet_Vertex__>::name, 
			Wrapper<Collection<Vertex*> >::name,
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Vertex_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Vertex_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Vertex_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_MSet_Vertex__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_MSet_Vertex__Methods(void);

PRIMITIVE STk_init_methods__MSet_Vertex__()
{
	genExtra_MSet_Vertex__Methods();
	return UNDEFINED;
}
